#ifndef _INCLUDE_aimms_AssignDataLevel
#define _INCLUDE_aimms_AssignDataLevel

#include "ValueLevel.h"
#include "aimms/Include.h"

namespace aimms{

   // This class handles the assignment of the value (indicated by slicenr) to position m_Tuple of AimmsIdentifier m_Par.
    template<typename T>
    class AssignDataLevel : public ValueLevel 
    {
        template<typename T> friend class SliceAssigner;

    private:
        AssignDataLevel(T* values,IMultiDimData* par, ITuple* tup)
            : m_Values(values)
            , m_Par(par)
            , m_Tuple(tup)
        {  
        }
        virtual ~AssignDataLevel()
        {
        }
        virtual void HandleSlice(int slicenr) 
        {
            m_Par->setValue(m_Tuple, m_Values[slicenr] ); 
        }
    private:
        T* m_Values; 
        IMultiDimData* m_Par;
        ITuple* m_Tuple;
    };
}
#endif