#ifndef _INCLUDE_aimms_CollectSliceDataLevel
#define _INCLUDE_aimms_CollectSliceDataLevel

#include "ValueLevel.h"
#include "aimms/Include.h"

namespace aimms{

   // This class collects the data of a slice 
    template<typename T>
    class CollectSliceDataLevel : public ValueLevel 
    {
        template<typename T> friend class SliceDataCollector;

    private:
        CollectSliceDataLevel(T* values, double*& slicedValues)
            : m_Values(values)
            , m_SlicedValues(slicedValues)
            , m_counter(0)
        {  
        }
        virtual ~CollectSliceDataLevel()
        {
        }
        virtual void HandleSliceNoTuple(int slicenr) 
        {
            m_SlicedValues[m_counter++] = (double) m_Values[slicenr] ; 
        }
    private:
        T* m_Values; 
        double*& m_SlicedValues;
        int m_counter;

    };
}
#endif