#include "IntegerDenseLevel.h"
#include "aimms/IElement.h"

namespace aimms{

    IntegerDenseLevel::IntegerDenseLevel(Level* parent, int first, int last, IElement* elem)
        : ElementLevel(parent, last - first + 1, elem)
        , m_First(first)
    {
    }
    void IntegerDenseLevel::HandleSliceNoTuple(int slicenr) {
         slicenr = slicenr * m_Card;
         for(  int i = 0 ; i < m_Card; ++i){
                m_Parent->HandleSliceNoTuple(i + slicenr);
         }
    }
    void IntegerDenseLevel::HandleSlice(int slicenr) {
         slicenr = slicenr * m_Card;
         for(  int i = 0 ; i < m_Card; ++i){
                m_Element->setIntLabel(i + m_First); 
                m_Parent->HandleSlice(i + slicenr);
         }
    }
    void IntegerDenseLevel::Apply(const double& value, int slicenr)
    {
        int i = m_Element->getIntLabel();
        m_Parent->Apply(value, slicenr*m_Card + i - m_First);
    }
}
