#ifndef _INCLUDE_aimms_IntegerDenseLevel
#define _INCLUDE_aimms_IntegerDenseLevel

#include "ElementLevel.h"

namespace aimms{

    // A level that iterates all elements of the domain set, assuming the datablock stores all integers in the range 
    class IntegerDenseLevel : public ElementLevel 
    {
        friend class Iterator;

    private:
        IntegerDenseLevel(Level* parent, int first, int last, IElement* elem);
        virtual void HandleSliceNoTuple(int slicenr); 
        virtual void HandleSlice(int slicenr); 
        virtual void Apply(const double& value, int slicenr); 

    private:
        int m_First;
    };
}
#endif