#ifndef _INCLUDE_aimms_IntegerSparseLevel
#define _INCLUDE_aimms_IntegerSparseLevel

#include "ElementLevel.h"

namespace aimms{

    // A level that iterates the supplied integers of the domain set, assuming the datablock stores all integers in the range 
    class IntegerSparseLevel : public ElementLevel 
    {
        friend class Iterator;

    private:
        IntegerSparseLevel(Level* parent, int first, int last, IElement* elem, int slicecard, int* slices);
        virtual void HandleSliceNoTuple(int slicenr); 
        virtual void HandleSlice(int slicenr); 
        virtual void Apply(const double& value, int slicenr); 

    private:
        int m_SliceCard;
        int* m_Slices;
        int m_First;
    };
}
#endif