#ifndef _INCLUDE_aimms_Iterator
#define _INCLUDE_aimms_Iterator

namespace aimms{

    class Iterator
    {
    protected:
        Iterator();

        Iterator(class IMultiDimData* par);
        virtual ~Iterator();

    public:      
        // Use this to initilalize the iterator if the datablock supplies ordinals in column major ordering(e.g. fortan)
        void SetOrdinalLevelsCMO(int** slices, int* slicecards, int* cards); 
        
        // Use this to initilalize the iterator if the datablock supplies sets as a dense range of integers in column major ordering(e.g. fortan)
        void SetIntegerLevelsCMO(int** slices, int* slicecards, int* firsts, int* lasts); 
        
        // Use this to initilalize the iterator if the datablock supplies ordinals in row major ordering(e.g. c++)
        void SetOrdinalLevelsRMO(int** slices, int* slicecards, int* cards); 
       
        // Use this to initilalize the iterator if the datablock supplies sets as a dense range of integers in row major ordering(e.g. c++)
        void SetIntegerLevelsRMO(int** slices, int* slicecards, int* firsts, int* lasts); 

    protected:    
        class ITuple* m_Tuple;
        class Level* m_Outerlevel;
    };
}
#endif