#include "OrdinalDenseLevel.h"
#include "aimms/Include.h"

namespace aimms{

    OrdinalDenseLevel::OrdinalDenseLevel(Level* parent, int card, IElement* elem)
        : ElementLevel(parent, card, elem)
    {
    }

    void OrdinalDenseLevel::HandleSliceNoTuple(int slicenr) {
         slicenr = slicenr * m_Card;
         for(  int ord = 1 ; ord <= m_Card; ++ord){
                m_Parent->HandleSliceNoTuple(ord - 1 + slicenr);
         }
    }

    void OrdinalDenseLevel::HandleSlice(int slicenr) {
         slicenr = slicenr * m_Card;
         for(int ord = 1; ord <= m_Card; ++ord){
             m_Element->setOrdinal(ord); 
             m_Parent->HandleSlice(ord - 1 + slicenr);
         }
    }

    void OrdinalDenseLevel::Apply(const double& value, int slicenr)
    {
        int ord = m_Element->getOrdinal();
            m_Parent->Apply(value, slicenr*m_Card + ord - 1);
    }
}