#include "OrdinalSparseLevel.h"
#include <algorithm>
#include "aimms/IElement.h"

namespace aimms{
    
    OrdinalSparseLevel::OrdinalSparseLevel(Level* parent, int card, IElement* elem, int slicecard, int* slices)
        : ElementLevel(parent, card, elem)
        , m_SliceCard(slicecard)
        , m_Slices(slices)
    {
    }
    void OrdinalSparseLevel::HandleSlice(int slicenr) {
         slicenr = slicenr * m_Card;
         for(  int nr = 0 ; nr < m_SliceCard; ++nr){
             m_Element->setOrdinal(m_Slices[nr]); 
             m_Parent->HandleSlice(m_Slices[nr]-1+slicenr);
         }
    }
    void OrdinalSparseLevel::HandleSliceNoTuple(int slicenr) {
         slicenr = slicenr * m_Card;
         for(int nr = 0; nr < m_SliceCard; ++nr){
            m_Parent->HandleSliceNoTuple(m_Slices[nr] - 1 + slicenr);
         }
    }
    void OrdinalSparseLevel::Apply(const double& value, int slicenr)
    {
        int ord = m_Element->getOrdinal();       
        int* pos = std::lower_bound(m_Slices, m_Slices + m_SliceCard, ord);
        if (pos<m_Slices+m_SliceCard && *pos == ord) {
            m_Parent->Apply(value, slicenr * m_Card + ord - 1);
        }
    }
}