#ifndef _INCLUDE_aimms_SliceAssigner
#define _INCLUDE_aimms_SliceAssigner

#include "Iterator.h"
#include "AssignDataLevel.h"
namespace aimms
{

    // This class assigns the data of a slice to the Aimms Identifier. 
    // The class must be initialized (once!) with one of the 'level setters'
    // and then can be used (once!) by calling iterate
    // e.g. SetOrdinalLevelsCMO().
    template<typename T>
    class SliceAssigner : public Iterator
    {
    public:
        SliceAssigner(class IMultiDimData* par, T* values)
            : Iterator(par)
        {
            m_Outerlevel = new AssignDataLevel<T>(values,par,m_Tuple);
        }
        void assignSlice()
        {
            m_Outerlevel->HandleSlice(0);
        }

    };
}
#endif
