#ifndef _INCLUDE_aimms_SliceDataCollector
#define _INCLUDE_aimms_SliceDataCollector

#include "Iterator.h"
#include "CollectSliceDataLevel.h"

namespace aimms
{

    // This class collects the data of a slice of the Aimms Identifier. 
    // The class must be initialized with one of the 'level setters' to define the slice and initialize the level iterators
    // collectData() will fill the value array with the values of the slice
    // This array can then be used in the 'setvalues' methods of IDataView
    class IMultiDimData;

    template<typename T>
    class SliceDataCollector : public Iterator
    {
    public:
        SliceDataCollector(class IMultiDimData* par, T* values, int card)
            : Iterator(par)
        {
            m_SlicedValues = new double[card];
            m_Outerlevel = new CollectSliceDataLevel<T>(values, m_SlicedValues);
        }
        virtual ~SliceDataCollector()
        {
            delete [] m_SlicedValues;
        }
        void collectData()
        {
            m_Outerlevel->HandleSliceNoTuple(0);
        }
        double* getData()
        {
            return m_SlicedValues;
        }
    private:
        double* m_SlicedValues;
    };
}
#endif
