
    program Sandbox

    ! to run this example you will need to adjust   Debugging > Environment   to:
    ! PATH=$(SolutionDir)\$(PlatformName)\$(ConfigurationName);$(AIMMS_SDK_HOME)\cpp\bin;%PATH%
    ! and adjust   Debugging > Working directory   to:
    ! $(SolutionDir)

    implicit none
    ! This is an example of a Fortran main program calling
    ! AIMMS through C routines. It uses the C Interoperability features
    ! of Fortran 2003

    ! This declares the interface for the C routines we'll call
    interface 
        integer function AimmsOpenProject(aimmsFolder, projectName, projectHandle, timeOut, maxFlushInBackground, maxMemoryFlushInBackground, maxBufferSize ) bind(c,name="AimmsOpenProject")
            use,intrinsic :: iso_c_binding 
            !DEC$ ATTRIBUTES DLLIMPORT :: AimmsOpenProject
            character(kind=C_CHAR),dimension(*) :: aimmsFolder
            character(kind=C_CHAR),dimension(*) :: projectName
            integer(kind=C_INT), intent(out) :: projectHandle
            integer(kind=C_INT), value, intent(in) ::  timeOut
            integer(kind=C_INT), value, intent(in) ::  maxFlushInBackground
            integer(kind=C_INT), value, intent(in) ::  maxMemoryFlushInBackground
            integer(kind=C_INT), value, intent(in) ::  maxBufferSize
        end function AimmsOpenProject

        integer function AimmsCloseProject( projectHandle ) bind(c,name="AimmsCloseProject")
            use,intrinsic :: iso_c_binding
            !DEC$ ATTRIBUTES DLLIMPORT :: AimmsCloseProject
            integer(kind=C_INT), value, intent(in) :: projectHandle
        end function AimmsCloseProject
        
        integer function AimmsIntAssignIdentifier( projectHandle, identifierName, dim, first, last, identifierAddress ) bind(c,name="AimmsIntAssignIdentifier")
            use,intrinsic :: iso_c_binding
            !DEC$ ATTRIBUTES DLLIMPORT :: AimmsAssignIdentifier
            integer(kind=C_INT), value, intent(in) :: projectHandle
            character(kind=C_CHAR), dimension(*), intent(in) :: identifierName
            integer(kind=C_INT), value, intent(in) :: dim
            integer(kind=C_INT), intent(in) :: first(5)
            integer(kind=C_INT), intent(in) :: last(5)
            real(C_FLOAT), dimension(*),intent(in) :: identifierAddress 
        end function AimmsIntAssignIdentifier
        
        integer function AimmsIntRetrieveIdentifier( projectHandle, identifierName, dim, first, last, identifierAddress) bind(c,name="AimmsIntRetrieveIdentifier")
            use,intrinsic :: iso_c_binding
            !DEC$ ATTRIBUTES DLLIMPORT :: AimmsRetrieveIdentifier
            integer(kind=C_INT), value, intent(in) :: projectHandle
            character(kind=C_CHAR), dimension(*), intent(in) :: identifierName
            integer(kind=C_INT), value, intent(in) :: dim
            integer(kind=C_INT), intent(in) :: first(5)
            integer(kind=C_INT), intent(in) :: last(5)
            real(C_FLOAT), dimension(*),intent(in) :: identifierAddress 
        end function AimmsIntRetrieveIdentifier
       
        integer function AimmsIntAssignIdentifierSlice( projectHandle, identifierName, dim, first, last, identifierAddress, sliceAddresses, sliceCard ) bind(c,name="AimmsIntAssignIdentifierSlice")
            use,intrinsic :: iso_c_binding
            !DEC$ ATTRIBUTES DLLIMPORT :: AimmsAssignIdentifier
            integer(kind=C_INT), value, intent(in) :: projectHandle
            character(kind=C_CHAR), dimension(*), intent(in) :: identifierName
            integer(kind=C_INT), value, intent(in) :: dim
            integer(kind=C_INT), intent(in) :: first(5)
            integer(kind=C_INT), intent(in) :: last(5)
            real(C_FLOAT), dimension(*),intent(in) :: identifierAddress 
            integer(kind=INT_PTR_KIND()), intent(in) :: sliceAddresses(5)
            integer(kind=C_INT), intent(in) :: sliceCard(5)
        end function AimmsIntAssignIdentifierSlice
        
        integer function AimmsIntRetrieveIdentifierSlice( projectHandle, identifierName, dim, first, last, identifierAddress, sliceAddresses, sliceCard ) bind(c,name="AimmsIntRetrieveIdentifierSlice")
            use,intrinsic :: iso_c_binding
            !DEC$ ATTRIBUTES DLLIMPORT :: AimmsRetrieveIdentifier
            integer(kind=C_INT), value, intent(in) :: projectHandle
            character(kind=C_CHAR), dimension(*), intent(in) :: identifierName
            integer(kind=C_INT), value, intent(in) :: dim
            integer(kind=C_INT), intent(in) :: first(5)
            integer(kind=C_INT), intent(in) :: last(5)
            real(C_FLOAT), dimension(*),intent(in) :: identifierAddress 
            integer(kind=INT_PTR_KIND()), intent(in) :: sliceAddresses(5)
            integer(kind=C_INT), intent(in) :: sliceCard(5)
        end function AimmsIntRetrieveIdentifierSlice

        
        integer function AimmsOrdAssignIdentifier( projectHandle, identifierName, dim, cards, identifierAddress ) bind(c,name="AimmsOrdAssignIdentifier")
            use,intrinsic :: iso_c_binding
            !DEC$ ATTRIBUTES DLLIMPORT :: AimmsAssignIdentifier
            integer(kind=C_INT), value, intent(in) :: projectHandle
            character(kind=C_CHAR), dimension(*), intent(in) :: identifierName
            integer(kind=C_INT), value, intent(in) :: dim
            integer(kind=C_INT), intent(in) :: cards(5)
            real(C_FLOAT), dimension(*),intent(in) :: identifierAddress 
        end function AimmsOrdAssignIdentifier
        
        integer function AimmsOrdRetrieveIdentifier( projectHandle, identifierName, dim, cards, identifierAddress) bind(c,name="AimmsOrdRetrieveIdentifier")
            use,intrinsic :: iso_c_binding
            !DEC$ ATTRIBUTES DLLIMPORT :: AimmsRetrieveIdentifier
            integer(kind=C_INT), value, intent(in) :: projectHandle
            character(kind=C_CHAR), dimension(*), intent(in) :: identifierName
            integer(kind=C_INT), value, intent(in) :: dim
            integer(kind=C_INT), intent(in) :: cards(5)
            real(C_FLOAT), dimension(*),intent(in) :: identifierAddress 
        end function AimmsOrdRetrieveIdentifier
       
        integer function AimmsOrdAssignIdentifierSlice( projectHandle, identifierName, dim, cards, identifierAddress, sliceAddresses, sliceCard ) bind(c,name="AimmsOrdAssignIdentifierSlice")
            use,intrinsic :: iso_c_binding
            !DEC$ ATTRIBUTES DLLIMPORT :: AimmsAssignIdentifier
            integer(kind=C_INT), value, intent(in) :: projectHandle
            character(kind=C_CHAR), dimension(*), intent(in) :: identifierName
            integer(kind=C_INT), value, intent(in) :: dim
            integer(kind=C_INT), intent(in) :: cards(5)
            real(C_FLOAT), dimension(*),intent(in) :: identifierAddress 
            integer(kind=INT_PTR_KIND()), intent(in) :: sliceAddresses(5)
            integer(kind=C_INT), intent(in) :: sliceCard(5)
        end function AimmsOrdAssignIdentifierSlice
        
        integer function AimmsOrdRetrieveIdentifierSlice( projectHandle, identifierName, dim, cards, identifierAddress, sliceAddresses, sliceCard ) bind(c,name="AimmsOrdRetrieveIdentifierSlice")
            use,intrinsic :: iso_c_binding
            !DEC$ ATTRIBUTES DLLIMPORT :: AimmsRetrieveIdentifier
            integer(kind=C_INT), value, intent(in) :: projectHandle
            character(kind=C_CHAR), dimension(*), intent(in) :: identifierName
            integer(kind=C_INT), value, intent(in) :: dim
            integer(kind=C_INT), intent(in) :: cards(5)
            real(C_FLOAT), dimension(*),intent(in) :: identifierAddress 
            integer(kind=INT_PTR_KIND()), intent(in) :: sliceAddresses(5)
            integer(kind=C_INT), intent(in) :: sliceCard(5)
        end function AimmsOrdRetrieveIdentifierSlice

        integer function AimmsRunProcedure( projectHandle, procedureName, returnCode )  bind (c, name = "AimmsRunProcedure")
            use,intrinsic :: iso_c_binding 
            !DEC$ ATTRIBUTES DLLIMPORT :: AimmsRunProcedure
            integer(kind=C_INT), value, intent(in) :: projectHandle
            character(kind=C_CHAR), dimension(*), intent(in) :: procedureName
            integer(kind=C_INT), intent(out) :: returnCode
        end function AimmsRunProcedure
        
    end interface

               

    real etime          ! Declare the type of etime()
    real timeBegin(2)   ! For receiving user and system time
    real totalBegin;
    real timeEnd(2)     ! For receiving user and system time
    real totalEnd;
    character(80) projectName
    character(80) aimmsFolder
    integer(4) projectHandle
    integer(4) i
    integer(4) j
    integer(kind=INT_PTR_KIND()) sliceAddresses(5)
    integer(4) sliceCard(5)
    integer(4) first(5)
    integer(4) last(5)
    integer(4) setI(4)
    integer(4) setJ(2)
    integer(4) ret
    integer(4) procedureRet
    real(4) dataA(4,2)
    real(4) dataB(4,2)
    real(4) dataC(4,2)
    real(4) special(1)
    real(4) dataBig(100,100,100)
    integer(4) setBig(100)
    integer(4) errorlength
    character(len=:), allocatable :: errormessage
    
    integer(4) timeOut
    integer(4) maxFlushInBackground
    integer(4) maxMemoryFlushInBackground
    integer(4) maxBufferSize

    
    ! Body of Sandbox
    projectName = "src\\NemsTestProject\\NemsTestProject.prj"C
    !aimmsFolder = "C:\\Program Files\\Paragon Decision Technology\\AIMMS 3.11"C
    aimmsFolder = "C:\\Program Files (x86)\\Paragon Decision Technology\\AIMMS 3.11"C
    projectHandle = 0
    timeOut = 30
    maxFlushInBackground = 16
    maxMemoryFlushInBackground = 1048576
    maxBufferSize = 1048576
    
    ret = AimmsOpenProject(aimmsFolder,projectName, projectHandle, timeOut, maxFlushInBackground, maxMemoryFlushInBackground, maxBufferSize)
    if (ret > 0) goto 300     
    
    
    first(1) = 1
    last(1) = 4
    first(2) = 1
    last(2) = 2

    ! no slicing:
    sliceAddresses(1) = loc(setBig)
    sliceAddresses(2) = loc(setBig)
    sliceAddresses(3) = loc(setBig)
    sliceAddresses(4) = 0
    sliceAddresses(5) = 0
    
    sliceCard(1) = 50
    sliceCard(2) = 50
    sliceCard(3) = 50
    sliceCard(4) = 0
    sliceCard(5) = 0
    
    do i = 1, 50
        setBig(i) = i*2
    end do

    do i = 1, 4
        setI(i) = i
    end do
    
    do j = 1, 2
        setJ(j) = j
    end do
        
    do i = 1, 4
        do j = 1, 2
            dataB(i,j) = i*10 + j
        end do
    end do
    
    ret = AimmsIntAssignIdentifier(projectHandle, "B"C, 2, first, last, dataB)
    if( ret > 0 ) goto 100

    do i = 1, 4
        do j = 1, 2
            dataC(i,j) = i*100 + j
        end do
    end do
    ret = AimmsIntAssignIdentifier(projectHandle, "C"C, 2, first, last, dataC)
    if( ret > 0 ) goto 100
    

    ret = AimmsRunProcedure(projectHandle, "MainExecution"C, procedureRet)
    if( ret > 0 ) goto 100
   
    ret = AimmsIntRetrieveIdentifier(projectHandle, "A"C, 2, first, last, dataA)
    if( ret > 0 ) goto 100            

    write(*,*) "A = " 
    do i = 1, 4
        write (*,"(6f7.2)") (dataA(i,j), j = 1, 2) 
    end do

    first(1) = 0
    last(1) = 0
    ret = AimmsIntRetrieveIdentifier(projectHandle, "Special"C, 0, first, last, Special)
    if( ret > 0 ) goto 100            

    write(*,*) "Special = ", Special


    first(1) = 1
    last(1) = 100
    first(2) = 1
    last(2) = 100
    first(3) = 1
    last(3) = 100
        
    totalBegin = etime(timeBegin)
    ret = AimmsIntRetrieveIdentifier(projectHandle, "Big"C, 3, first, last, dataBig)
    totalEnd = etime(timeEnd)
    print *, 'int-retrieve: total=', totalEnd-totalBegin
    if( ret > 0 ) goto 100            

    totalBegin = etime(timeBegin)
    ret = AimmsIntRetrieveIdentifierSlice(projectHandle, "Big"C, 3, first, last, dataBig, sliceAddresses, sliceCard)
    totalEnd = etime(timeEnd)
    print *, 'int-retrieve-slice: total=', totalEnd-totalBegin
    if( ret > 0 ) goto 100            


    totalBegin = etime(timeBegin)
    ret = AimmsIntAssignIdentifier(projectHandle, "Big"C, 3, first, last, dataBig)
    totalEnd = etime(timeEnd)
    print *, 'int-assign: total=', totalEnd-totalBegin
    if( ret > 0 ) goto 100   
    
    totalBegin = etime(timeBegin)
    ret = AimmsIntAssignIdentifierSlice(projectHandle, "Big"C, 3, first, last, dataBig, sliceAddresses, sliceCard)
    totalEnd = etime(timeEnd)
    print *, 'int-assign-slice: total=', totalEnd-totalBegin
    if( ret > 0 ) goto 100
    
    first(1) = 1
    last(1) = 4
    first(2) = 1
    last(2) = 2

    ! no slicing:
    sliceAddresses(1) = loc(setBig)
    sliceAddresses(2) = loc(setBig)
    sliceAddresses(3) = loc(setBig)
    sliceAddresses(4) = 0
    sliceAddresses(5) = 0
    
    sliceCard(1) = 50
    sliceCard(2) = 50
    sliceCard(3) = 50
    sliceCard(4) = 0
    sliceCard(5) = 0
    
    do i = 1, 50
        setBig(i) = i*2
    end do

    do i = 1, 4
        setI(i) = i
    end do
    
    do j = 1, 2
        setJ(j) = j
    end do
        
    do i = 1, 4
        do j = 1, 2
            dataB(i,j) = i*10 + j
        end do
    end do
    
    ret = AimmsOrdAssignIdentifier(projectHandle, "B"C, 2, last, dataB)
    if( ret > 0 ) goto 100

    do i = 1, 4
        do j = 1, 2
            dataC(i,j) = i*100 + j
        end do
    end do
    ret = AimmsOrdAssignIdentifier(projectHandle, "C"C, 2, last, dataC)
    if( ret > 0 ) goto 100
    

    ret = AimmsRunProcedure(projectHandle, "MainExecution"C, procedureRet)
    if( ret > 0 ) goto 100
   
    ret = AimmsOrdRetrieveIdentifier(projectHandle, "A"C, 2, last, dataA)
    if( ret > 0 ) goto 100            

    write(*,*) "A = " 
    do i = 1, 4
        write (*,"(6f7.2)") (dataA(i,j), j = 1, 2) 
    end do

    first(1) = 0
    last(1) = 0
    ret = AimmsOrdRetrieveIdentifier(projectHandle, "Special"C, 0, last, Special)
    if( ret > 0 ) goto 100            

    write(*,*) "Special = ", Special


    first(1) = 1
    last(1) = 100
    first(2) = 1
    last(2) = 100
    first(3) = 1
    last(3) = 100
        
    totalBegin = etime(timeBegin)
    ret = AimmsOrdRetrieveIdentifier(projectHandle, "Big"C, 3, last, dataBig)
    totalEnd = etime(timeEnd)
    print *, 'ord-retrieve: total=', totalEnd-totalBegin
    if( ret > 0 ) goto 100            

    totalBegin = etime(timeBegin)
    ret = AimmsOrdRetrieveIdentifierSlice(projectHandle, "Big"C, 3, last, dataBig, sliceAddresses, sliceCard)
    totalEnd = etime(timeEnd)
    print *, 'ord-retrieve-slice: total=', totalEnd-totalBegin
    if( ret > 0 ) goto 100            


    totalBegin = etime(timeBegin)
    ret = AimmsOrdAssignIdentifier(projectHandle, "Big"C, 3, last, dataBig)
    totalEnd = etime(timeEnd)
    print *, 'ord-assign: total=', totalEnd-totalBegin
    if( ret > 0 ) goto 100   
    
    totalBegin = etime(timeBegin)
    ret = AimmsOrdAssignIdentifierSlice(projectHandle, "Big"C, 3, last, dataBig, sliceAddresses, sliceCard)
    totalEnd = etime(timeEnd)
    print *, 'ord-assign-slice: total=', totalEnd-totalBegin
    if( ret > 0 ) goto 100   
    first(1) = 1
    last(1) = 4
    first(2) = 1
    last(2) = 2

    ! no slicing:
    sliceAddresses(1) = loc(setBig)
    sliceAddresses(2) = loc(setBig)
    sliceAddresses(3) = loc(setBig)
    sliceAddresses(4) = 0
    sliceAddresses(5) = 0
    
    sliceCard(1) = 50
    sliceCard(2) = 50
    sliceCard(3) = 50
    sliceCard(4) = 0
    sliceCard(5) = 0
    
    do i = 1, 50
        setBig(i) = i*2
    end do

    do i = 1, 4
        setI(i) = i
    end do
    
    do j = 1, 2
        setJ(j) = j
    end do
        
    do i = 1, 4
        do j = 1, 2
            dataB(i,j) = i*10 + j
        end do
    end do
    
    ret = AimmsIntAssignIdentifier(projectHandle, "B"C, 2, first, last, dataB)
    if( ret > 0 ) goto 100

    do i = 1, 4
        do j = 1, 2
            dataC(i,j) = i*100 + j
        end do
    end do
    ret = AimmsIntAssignIdentifier(projectHandle, "C"C, 2, first, last, dataC)
    if( ret > 0 ) goto 100
    

    ret = AimmsRunProcedure(projectHandle, "MainExecution"C, procedureRet)
    if( ret > 0 ) goto 100
   
    ret = AimmsIntRetrieveIdentifier(projectHandle, "A"C, 2, first, last, dataA)
    if( ret > 0 ) goto 100            

    write(*,*) "A = " 
    do i = 1, 4
        write (*,"(6f7.2)") (dataA(i,j), j = 1, 2) 
    end do

    first(1) = 0
    last(1) = 0
    ret = AimmsIntRetrieveIdentifier(projectHandle, "Special"C, 0, first, last, Special)
    if( ret > 0 ) goto 100            

    write(*,*) "Special = ", Special


    first(1) = 1
    last(1) = 100
    first(2) = 1
    last(2) = 100
    first(3) = 1
    last(3) = 100
        
    totalBegin = etime(timeBegin)
    ret = AimmsIntRetrieveIdentifier(projectHandle, "Big"C, 3, first, last, dataBig)
    totalEnd = etime(timeEnd)
    print *, 'int-retrieve: total=', totalEnd-totalBegin
    if( ret > 0 ) goto 100            

    totalBegin = etime(timeBegin)
    ret = AimmsIntRetrieveIdentifierSlice(projectHandle, "Big"C, 3, first, last, dataBig, sliceAddresses, sliceCard)
    totalEnd = etime(timeEnd)
    print *, 'int-retrieve-slice: total=', totalEnd-totalBegin
    if( ret > 0 ) goto 100            


    totalBegin = etime(timeBegin)
    ret = AimmsIntAssignIdentifier(projectHandle, "Big"C, 3, first, last, dataBig)
    totalEnd = etime(timeEnd)
    print *, 'int-assign: total=', totalEnd-totalBegin
    if( ret > 0 ) goto 100   
    
    totalBegin = etime(timeBegin)
    ret = AimmsIntAssignIdentifierSlice(projectHandle, "Big"C, 3, first, last, dataBig, sliceAddresses, sliceCard)
    totalEnd = etime(timeEnd)
    print *, 'int-assign-slice: total=', totalEnd-totalBegin
    if( ret > 0 ) goto 100
    
    first(1) = 1
    last(1) = 4
    first(2) = 1
    last(2) = 2

    ! no slicing:
    sliceAddresses(1) = loc(setBig)
    sliceAddresses(2) = loc(setBig)
    sliceAddresses(3) = loc(setBig)
    sliceAddresses(4) = 0
    sliceAddresses(5) = 0
    
    sliceCard(1) = 50
    sliceCard(2) = 50
    sliceCard(3) = 50
    sliceCard(4) = 0
    sliceCard(5) = 0
    
    do i = 1, 50
        setBig(i) = i*2
    end do

    do i = 1, 4
        setI(i) = i
    end do
    
    do j = 1, 2
        setJ(j) = j
    end do
        
    do i = 1, 4
        do j = 1, 2
            dataB(i,j) = i*10 + j
        end do
    end do
    
    ret = AimmsOrdAssignIdentifier(projectHandle, "B"C, 2, last, dataB)
    if( ret > 0 ) goto 100

    do i = 1, 4
        do j = 1, 2
            dataC(i,j) = i*100 + j
        end do
    end do
    ret = AimmsOrdAssignIdentifier(projectHandle, "C"C, 2, last, dataC)
    if( ret > 0 ) goto 100
    

    ret = AimmsRunProcedure(projectHandle, "MainExecution"C, procedureRet)
    if( ret > 0 ) goto 100
   
    ret = AimmsOrdRetrieveIdentifier(projectHandle, "A"C, 2, last, dataA)
    if( ret > 0 ) goto 100            

    write(*,*) "A = " 
    do i = 1, 4
        write (*,"(6f7.2)") (dataA(i,j), j = 1, 2) 
    end do

    first(1) = 0
    last(1) = 0
    ret = AimmsOrdRetrieveIdentifier(projectHandle, "Special"C, 0, last, Special)
    if( ret > 0 ) goto 100            

    write(*,*) "Special = ", Special


    first(1) = 1
    last(1) = 100
    first(2) = 1
    last(2) = 100
    first(3) = 1
    last(3) = 100
        
    totalBegin = etime(timeBegin)
    ret = AimmsOrdRetrieveIdentifier(projectHandle, "Big"C, 3, last, dataBig)
    totalEnd = etime(timeEnd)
    print *, 'ord-retrieve: total=', totalEnd-totalBegin
    if( ret > 0 ) goto 100            

    totalBegin = etime(timeBegin)
    ret = AimmsOrdRetrieveIdentifierSlice(projectHandle, "Big"C, 3, last, dataBig, sliceAddresses, sliceCard)
    totalEnd = etime(timeEnd)
    print *, 'ord-retrieve-slice: total=', totalEnd-totalBegin
    if( ret > 0 ) goto 100            


    totalBegin = etime(timeBegin)
    ret = AimmsOrdAssignIdentifier(projectHandle, "Big"C, 3, last, dataBig)
    totalEnd = etime(timeEnd)
    print *, 'ord-assign: total=', totalEnd-totalBegin
    if( ret > 0 ) goto 100   
    
    totalBegin = etime(timeBegin)
    ret = AimmsOrdAssignIdentifierSlice(projectHandle, "Big"C, 3, last, dataBig, sliceAddresses, sliceCard)
    totalEnd = etime(timeEnd)
    print *, 'ord-assign-slice: total=', totalEnd-totalBegin
    if( ret > 0 ) goto 100   
    
    goto 200
100 call getLastError
200 ret =  AimmsCloseProject( projectHandle)
300 if (ret > 0) then
        call getLastError
    end if
    
        
    end program Sandbox


    subroutine getLastError()
        interface 
           integer function AimmsGetLastErrorMessage( textBufferLen, textBuffer) bind(c,name="AimmsGetLastErrorMessage")
                use,intrinsic :: iso_c_binding
                !DEC$ ATTRIBUTES DLLIMPORT :: AimmsGetLastErrorMessage 
                integer(kind=C_INT), intent(inout) :: textBufferLen
                character(kind=C_CHAR), dimension(*), intent(inout) :: textBuffer
            end function AimmsGetLastErrorMessage
        end interface

        integer(4) :: length
        integer(4) :: ret 
        character(len=:), allocatable :: errormessage
        
        length = 0;
        ret = AimmsGetLastErrorMessage(length, errormessage)
        if (ret == 0) then
            allocate(character(len = length) ::  errormessage)    
            ret = AimmsGetLastErrorMessage(length, errormessage)
            write(*,*) errormessage
        end if
    end subroutine 